package controleurs;

import java.io.IOException;
import jakarta.servlet.http.*;
import jakarta.servlet.annotation.WebServlet;
import dao.UtilisateurDAO;
import dto.Utilisateur;
import org.apache.tomcat.jakartaee.commons.lang3.StringEscapeUtils;

@WebServlet("/Authent")
public class AccountAuthent extends HttpServlet {

    UtilisateurDAO utilisateurDAO = new UtilisateurDAO();

    protected void service(HttpServletRequest req, HttpServletResponse res)
            throws IOException {

        HttpSession session = req.getSession(true);
        String login = StringEscapeUtils.escapeHtml4(req.getParameter("login"));
        String mdp = StringEscapeUtils.escapeHtml4(req.getParameter("mdp"));

        if (login == null || login.isEmpty() || mdp == null || mdp.isEmpty()) {
            res.sendRedirect("Menu");
            return;
        }

        Utilisateur utilisateur = utilisateurDAO.checkUser(login, mdp);

        if (utilisateur != null) {
            session.setAttribute("utilisateur", utilisateur);
            res.sendRedirect("Menu");
        } else {
            res.sendRedirect("/LilleConnect/login.html");
        }
    }
}
