package controleurs;

import java.io.IOException;
import jakarta.servlet.http.*;
import jakarta.servlet.annotation.WebServlet;
import dao.UtilisateurDAO;
import dto.Utilisateur;
import org.apache.tomcat.jakartaee.commons.lang3.StringEscapeUtils;

@WebServlet("/Create")
public class AccountCreate extends HttpServlet {
    UtilisateurDAO utilisateurDAO = new UtilisateurDAO();

    protected void service(HttpServletRequest req, HttpServletResponse res)
            throws IOException {
        res.setContentType("text/html;charset=UTF-8");
        HttpSession session = req.getSession(true);

        String prenom = StringEscapeUtils.escapeHtml4(req.getParameter("prenom"));
        String nom = StringEscapeUtils.escapeHtml4(req.getParameter("nom"));
        String mail = StringEscapeUtils.escapeHtml4(req.getParameter("mail"));
        String mdp = StringEscapeUtils.escapeHtml4(req.getParameter("mdp"));

        if (prenom == null || nom == null || mail == null || mdp == null ||
                prenom.isEmpty() || nom.isEmpty() || mail.isEmpty() || mdp.isEmpty()) {
            res.sendRedirect("new.html");
            return;
        }

        if (utilisateurDAO.userExist(mail)) {
            res.sendRedirect("new.html");
            return;
        }

        Utilisateur utilisateur = new Utilisateur(mail, nom, prenom);

        if (utilisateurDAO.addUser(utilisateur, mdp)) {
            utilisateur.setId(utilisateurDAO.getUserIdByEmail(mail));
            session.setAttribute("utilisateur", utilisateur);
            res.sendRedirect("Menu");
        } else {
            res.sendRedirect("login.html");
        }
    }
}
