package controleurs;

import java.io.IOException;
import dao.ParticipantFilDAO;
import jakarta.servlet.*;
import jakarta.servlet.http.*;
import jakarta.servlet.annotation.WebServlet;
import dto.Utilisateur;
import org.apache.tomcat.jakartaee.commons.lang3.StringEscapeUtils;

@WebServlet("/LeaveFil")
public class FilLeave extends HttpServlet {

    protected void service(HttpServletRequest req, HttpServletResponse res)
            throws IOException {
        HttpSession session = req.getSession(false);
        Utilisateur u = (Utilisateur) session.getAttribute("utilisateur");
        if (u == null || u.getId() == 0) {
            res.sendRedirect("login.html");
            return;
        }
        int uid = u.getId();

        String filIdParam = StringEscapeUtils.escapeHtml4(req.getParameter("filId"));
        if (filIdParam == null || filIdParam.isEmpty()) {
            res.sendRedirect("Menu");
            return;
        }

        int filId = -1;
        try {
            filId = Integer.parseInt(filIdParam);
        } catch (NumberFormatException e) {
            res.sendRedirect("Menu");
            return;
        }

        if (filId <= 0) {
            res.sendRedirect("Menu");
            return;
        }

        ParticipantFilDAO participantFilDAO = new ParticipantFilDAO();
        participantFilDAO.deleteUserById(uid, filId);
        res.sendRedirect("Menu");
    }
}
