package controleurs;
import java.nio.charset.StandardCharsets;
import java.time.Instant;
import java.util.Date;
import java.util.UUID;
import javax.crypto.SecretKey;
import io.jsonwebtoken.*;
import io.jsonwebtoken.security.Keys;

public class JwtManager {
    private static final String SECRET_KEY = "bachibouzoukbachibouzoukbachibouzoukbachibouzouk";

    public static String createJWT(String login) {

        byte[] keyBytes = SECRET_KEY.getBytes(StandardCharsets.UTF_8);
        SecretKey signingKey = Keys.hmacShaKeyFor(keyBytes);

        Instant now = Instant.now();
        Instant expiration = now.plusSeconds(1200); // 20 mn
        Date expDate = Date.from(expiration);

        String token = Jwts.builder()
                .id(UUID.randomUUID().toString().replace("-", ""))
                .issuedAt(Date.from(now))
                .subject(login)
                .issuer("tom.dequesnes.etu@univ-lille.fr")
                .expiration(expDate)
                .signWith(signingKey)
                .compact();

        return token;
    }

    public static Claims decodeJWT(String jwt) throws Exception {
        byte[] keyBytes = SECRET_KEY.getBytes(StandardCharsets.UTF_8);
        SecretKey signingKey = Keys.hmacShaKeyFor(keyBytes);

        JwtParser parser = Jwts.parser()
                .verifyWith(signingKey)
                .build();

        Claims claims = parser.parseSignedClaims(jwt).getPayload();
        return claims;
    }

}
