package controleurs;

import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import dao.FilDAO;
import dao.MessageDAO;
import dao.ParticipantFilDAO;
import dao.UtilisateurDAO;
import dto.Fil;
import dto.Utilisateur;
import jakarta.servlet.*;
import jakarta.servlet.http.*;
import jakarta.servlet.annotation.WebServlet;
import org.apache.tomcat.jakartaee.commons.lang3.StringEscapeUtils;

@WebServlet("/Menu")
public class Menu extends HttpServlet {

    protected void service(HttpServletRequest req, HttpServletResponse res)
            throws ServletException, IOException {
        res.setContentType("text/html;charset=UTF-8");
        HttpSession session = req.getSession(true);
        Utilisateur utilisateur = (Utilisateur) session.getAttribute("utilisateur");
        if (utilisateur == null) {
            res.sendRedirect("login.html");
        } else {
            FilDAO filDAO = new FilDAO();
            ParticipantFilDAO participantFilDAO = new ParticipantFilDAO();
            List<Fil> fils = filDAO.getFilsByUser(utilisateur.getId());
            req.setAttribute("fils", fils);
            String rese = StringEscapeUtils.escapeHtml4(req.getParameter("filId"));
            if (rese != null) {
                if (participantFilDAO.partFil(Integer.parseInt(rese), utilisateur.getId())) {
                    MessageDAO mDAO = new MessageDAO();
                    mDAO.checkTimeMessage();
                    List<dto.Message> messages = mDAO.getLastMessages(Integer.parseInt(rese));
                    req.setAttribute("message", messages);
                    req.setAttribute("filId", rese);

                    Map<Integer, String> userNames = new HashMap<>();
                    UtilisateurDAO utilisateurDAO = new UtilisateurDAO();
                    for (dto.Message mess : messages) {
                        if (!userNames.containsKey(mess.getUid())) {
                            Utilisateur user = utilisateurDAO.getUserById(mess.getUid());
                            userNames.put(mess.getUid(), user.getPrenom() + " " + user.getNom());
                        }
                    }

                    // Vérifier si l'utilisateur est admin du fil
                    boolean isAdmin = participantFilDAO.isAdmin(utilisateur, Integer.parseInt(rese));

                    // Envoyer les données à la JSP
                    req.setAttribute("isAdmin", isAdmin);

                    req.setAttribute("userNames", userNames);

                    List<Utilisateur> liste = participantFilDAO.getUsersByFilId(Integer.parseInt(rese));

                    req.setAttribute("listeUsers", liste);
                }
            }
            req.getRequestDispatcher("menu.jsp").forward(req, res);
        }
    }
}
