package controleurs;

import java.io.*;
import dao.UtilisateurDAO;
import jakarta.servlet.*;
import jakarta.servlet.http.*;
import jakarta.servlet.annotation.WebServlet;
import dto.Utilisateur;
import org.apache.tomcat.jakartaee.commons.lang3.StringEscapeUtils;

@WebServlet("/UserInfo")
public class UserInfo extends HttpServlet {

    public void doGet(HttpServletRequest req, HttpServletResponse res)
            throws ServletException, IOException {
        res.setContentType("text/html;charset=UTF-8");

        HttpSession session = req.getSession(true);
        Utilisateur utilisateur = (Utilisateur) session.getAttribute("utilisateur");

        if (utilisateur == null || utilisateur.getId() == 0) {
            res.sendRedirect("login.html");
            return;
        }

        req.setAttribute("email", StringEscapeUtils.escapeHtml4(utilisateur.getEmail()));
        req.setAttribute("nom", StringEscapeUtils.escapeHtml4(utilisateur.getNom()));
        req.setAttribute("prenom", StringEscapeUtils.escapeHtml4(utilisateur.getPrenom()));

        String token = JwtManager.createJWT(utilisateur.getEmail());
        req.setAttribute("token", token);

        req.getRequestDispatcher("user.jsp").forward(req, res);
    }

    public void doPost(HttpServletRequest req, HttpServletResponse res)
            throws IOException {
        res.setContentType("text/html;charset=UTF-8");
        HttpSession session = req.getSession(true);
        Utilisateur user = (Utilisateur) session.getAttribute("utilisateur");

        if (user == null || user.getId() == 0) {
            res.sendRedirect("login.html");
            return;
        }

        String email = StringEscapeUtils.escapeHtml4(req.getParameter("mail"));
        String nom = StringEscapeUtils.escapeHtml4(req.getParameter("nom"));
        String prenom = StringEscapeUtils.escapeHtml4(req.getParameter("prenom"));
        String mdp = StringEscapeUtils.escapeHtml4(req.getParameter("mdp"));

        UtilisateurDAO utilisateurDAO = new UtilisateurDAO();
        user = utilisateurDAO.editUser(user, email, nom, prenom, mdp);

        if (user != null) {
            session.setAttribute("utilisateur", user);
        }
        res.sendRedirect("Menu");
    }
}
