package dao;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class ConfigLoader {
    private static final Properties properties = new Properties();

    static {
        try (InputStream input = ConfigLoader.class.getClassLoader().getResourceAsStream("res/config.prop")) {
            if (input == null) {
                throw new IOException("Fichier config.prop introuvable");
            }
            properties.load(input);
        } catch (IOException e) {
            System.err.println("Erreur de chargement du fichier de configuration : " + e.getMessage());
        }
    }

    public static String getProperty(String key) {
        return properties.getProperty(key);
    }
}
