package dao;

import dto.Fil;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

public class FilDAO {

    private final DS ds;

    public FilDAO() {
        this.ds = new DS();
    }
    public List<Fil> getFilsByUser(int id) {
        List<Fil> fils = new ArrayList<>();
        String query = "SELECT F.F_ID, F.TITRE FROM FIL AS F JOIN PARTICIPANT_FIL AS P ON F.F_ID = P.FP_ID WHERE P.UP_ID = ?";

        try (Connection con = ds.getConnection()) {
            PreparedStatement ps = con.prepareStatement(query);
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();
            while (rs.next()) {
                Fil fil = new Fil();
                fil.setFid(rs.getInt("F_ID"));
                fil.setTitre(rs.getString("TITRE"));
                fils.add(fil);
            }
        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
        return fils;
    }

    public int addFil(int uid, String titre, List<String> users, boolean admin) {
        String insertFilQuery = "INSERT INTO fil (titre) VALUES (?) RETURNING f_id;";
        int filId = -1;
        ParticipantFilDAO participantFilDAO = new ParticipantFilDAO();
        UtilisateurDAO utilisateurDAO = new UtilisateurDAO();

        try (Connection con = ds.getConnection();
                PreparedStatement psFil = con.prepareStatement(insertFilQuery)) {
            psFil.setString(1, titre);
            ResultSet rs = psFil.executeQuery();

            if (rs.next()) {
                filId = rs.getInt(1);
                participantFilDAO.addParticipant(uid, filId, true);
                for (String email : users) {
                    int userId = utilisateurDAO.getUserIdByEmail(email);
                    if (userId != -1) {
                        participantFilDAO.addParticipant(userId, filId, admin);
                    }
                }
            }
        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
        return filId;
    }
}
