package dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class LikeDAO {

    private final DS ds;

    public LikeDAO() {
        this.ds = new DS();
    }

    public boolean hasLiked(int mid, int user) {
        String checkLikeQuery = "SELECT COUNT(*) FROM LIKES WHERE M_ID = ? AND U_ID = ?";
        try (Connection con = ds.getConnection();
                PreparedStatement ps = con.prepareStatement(checkLikeQuery)) {

            ps.setInt(1, mid);
            ps.setInt(2, user);
            ResultSet rs = ps.executeQuery();
            return rs.next() && rs.getInt(1) > 0;
        } catch (SQLException e) {
            System.err.println(e.getMessage());
        }
        return false;
    }

    public void addLike(int mid, int user) {
        String insertLikeQuery = "INSERT INTO LIKES (M_ID, U_ID) VALUES (?, ?)";
        try (Connection con = ds.getConnection();
                PreparedStatement ps = con.prepareStatement(insertLikeQuery)) {

            ps.setInt(1, mid);
            ps.setInt(2, user);
            ps.executeUpdate();
        } catch (SQLException e) {
            System.err.println(e.getMessage());
        }
    }

    public void removeLike(int mid, int user) {
        String deleteLikeQuery = "DELETE FROM LIKES WHERE M_ID = ? AND U_ID = ?";
        try (Connection con = ds.getConnection();
                PreparedStatement ps = con.prepareStatement(deleteLikeQuery)) {

            ps.setInt(1, mid);
            ps.setInt(2, user);
            ps.executeUpdate();
        } catch (SQLException e) {
            System.err.println(e.getMessage());
        }
    }

    public int getNbLike(int mid) {
        String query = "SELECT count(*) FROM LIKES WHERE m_id = ?";
        int nbLikes = 0;
        try (Connection con = ds.getConnection();
                PreparedStatement ps = con.prepareStatement(query)) {
            ps.setInt(1, mid);
            try (ResultSet rs = ps.executeQuery()) {
                if (rs.next())
                    nbLikes = rs.getInt(1);
            }
        } catch (SQLException e) {
            System.err.println(e.getMessage());
        }
        return nbLikes;
    }

}
