<%@ page import="dto.Utilisateur" %>
<%@ page import="dao.ParticipantFilDAO" %>
<%@ page import="java.util.List" %>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Ajouter Membre(s)</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" rel="stylesheet">
    <link href="css/style.css" rel="stylesheet">
    <link rel="icon" href="images/LilleConnect.png" type="image/png">
</head>
<body>
<div class="container">
    <form action="addUserFil" method="POST">
        <h2>Ajouter Membre(s)</h2>
        <div class="mb-3">
            <label for="utilisateurs" class="form-label">Utilisateur(s)</label>
            <input type="text" class="form-control" id="utilisateurs" name="utilisateurs">
            <p>Separez les mails utilisateurs par des "/"</p>
            <label for="admin" class="form-label">Admin ? (true / false)</label>
            <input type="text" class="form-control" id="admin" name="admin">
            <input type="hidden" name="filId" value="<%= request.getParameter("filId") %>">
        </div>
        <button type="submit" class="btn btn-primary">Ajouter</button>
    </form>
</div>

<div class="container">
    <h2>Liste des Membres du Fil</h2>
    <ul class="list-group">
        <%
            List<Utilisateur> utilisateurs = (List<Utilisateur>) request.getAttribute("listeUsers");

            if (utilisateurs != null && !utilisateurs.isEmpty()) {
                for (Utilisateur user : utilisateurs) {
        %>
        <li class="list-group-item d-flex justify-content-between align-items-center">
            <%= user.getPrenom() %> <%= user.getNom() %> - <%= user.getEmail() %>
            <form action="UserFil" method="post" style="display:inline;">
                <input type="hidden" name="userId" value="<%= user.getId() %>">
                <input type="hidden" name="filId" value="<%= request.getParameter("filId") %>">
                <button type="submit" class="btn btn-danger btn-sm">Supprimer</button>
            </form>
        </li>
        <%
            }
        } else {
        %>
        <li class="list-group-item">Aucun membre trouvé.</li>
        <% } %>
    </ul>
    <div class="mt-3">
        <a href="Menu?filId=<%=request.getParameter("filId")%>" class="btn btn-secondary">Retour au menu</a>
    </div>
</div>

<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-YvpcrYf0tY3lHB60NNkmXc5s9fDVZLESaAA55NDzOxhy9GkcIdslK1eN7N6jIeHz" crossorigin="anonymous"></script>
</body>
</html>
